# Contributing

I am open to, and grateful for, any contributions made to this project.

## Commit Messages

Please write and use meaningful and helpful commit messages for your contributions and changes.

## Testing

All changes are expected to continue to pass the tests in place.

If you are adding new functionality to the library you are expected to also unit test and create appropriate testing for your additions

IF you are editing exsiting functionality please ensure all unit tests remain passing

## Developing

- Please stick to the [standardjs](https://standardjs.com/) style for development
- This lib is written using ES6 please keep all changes to this version
  - This excludes the import/export since node does not support it internally yet
- Make sure all current and new units tests are fully passing
- Please try to keep the flow consistent to what is already present

## Releasing

Currently the CHANGELOG is updated manually before each release. You can document your changes here, or I will document them using your provided commit messages.

Releases follow standard [semantic versioning](https://semver.org/).

I will handle publishing to npm for now after your PR is merged in
